require(tidyverse)
require(tidyr)
require(ggpmisc)
require(svMisc)
require(CBPS)
require(geiger)
require(lsa)
require(DescTools)
require(MVTests)
require(caret)
require(dbarts)
require(parallel)
require(gbm)
require(pbmcapply)
require(extraDistr)
require(plyr)
require(data.table)
RNGkind("L'Ecuyer-CMRG")
require(schoenberg)
require(lsr)
require(car)
require(psych)
require(quickmatch)
require(devtools)
require(Matching)
require(rgenoud)
require(optmatch)
require(Hmisc)
require(rio)
require(sjstats)
require(schoolmath)
require(MatchIt)
require(magrittr)
require(xlsx)
require(writexl)
require(ncvreg)
require(np)
require(dplyr)
require(tidyverse)
require(survey)
require(sampling)
require(KernSmooth)
require(caTools)
require(gridExtra)
require(lars)
require(glmnet)
require(Metrics)
Sample=Vectorize(sample)
Dat = function(x, p, size, seed){
  set.seed(seed)
  return(x[x$part==p,][sample(nrow(x[x$part==p,]), size),])
}
Dat.v = Vectorize(Dat, vectorize.args=c("size", "p"))
require(MASS)
require(mgcv) 
require(parallel)
require(ranger)
require(xgboost)
library(dplyr)
library(mgcv)
library(tidymv)
require(haven)
`%notin%` <- Negate(`%in%`)

require(survey)
require(svrep)
require(svMisc)
require(doParallel)
require(splines)
require(future.apply)
require(latex2exp)


sim.f2 = function(N,
                  nA,
                  nB,
                  nsim,
                  mod, 
                  seed, 
                  r){

  if (mod == "f1"){
    set.seed(seed)
    x1 = rnorm(N, mean = 2, sd = 1)
    x2 = rnorm(N, mean = 2, sd = 1)
    x3 = rnorm(N, mean = 4, sd = 1)
    x4 = rnorm(N, mean = 4, sd = 1)
    y = rnorm(N, 4*x1+4*x2 + 2*x3 + 2*x4, 3)
    
    X=cbind(x1, x2, x3, x4)
    p = ncol(X)
    
  }
  
  if (mod == 'f2'){
    set.seed(seed)
    x1= runif(N, min = 0, max = 4) 
    x2= runif(N, min = 0, max = 4) 
    x3= runif(N, min = 4, max = 8)
    x4 = runif(N, min = 4, max = 8)
    y = rnorm(n = N,
              4*x1 + 4*x2 + 2*x3 + 2*x4 + 
      (x1+x2)^2 + (x3+x4)^2, sd = 17.5) 
    X = cbind(x1, x2, x3, x4) 
    colnames(X) = c('x1', 'x2', 'x3', 'x4')
    p = 4

  }
  
  if (mod == "f3"){
    set.seed(seed)
    x1 = runif(n=N, 
               min = -5,
               max = 5)
    x2 = runif(n=N, 
               min = -5,
               max = 5)
    x3 = runif(n=N, 
               min = -5,
               max = 5)
    x4 = runif(n=N, 
               min = -5,
               max = 5)
    
    x5 = runif(n = N,
               min = -5,
               max = 5)
    x6 = runif(n = N,
               min = -5,
               max = 5)
    err = rnorm(n = N,
                   mean = 0,
                   sd = sqrt(1.8))
    X = data.frame(x1, x2, x3, x4, x5, x6)
    p = ncol(X)
    y = x1 + 2.121*x2^2 + 2*ifelse(abs(x3) > mean(x3), 1, 0) + .873*3*log(abs(x1))*abs(x3) + .894*3*x2*x4 + 2*3*ifelse(abs(x5) > mean(x5), 1, 0) +.464*3*exp(x6) + err
  }
  
  if (mod == "f4"){
    x1 = runif(n=N, 
               min = -5,
               max = 5)
    x2 = runif(n=N, 
               min = 5,
               max = 10)
    x3 = runif(n=N, 
               min = -5,
               max = 5)
    x4 = runif(n=N, 
               min = 5,
               max = 10)
    
    x5 = runif(n = N,
               min = -5,
               max = 5)
    x6 = runif(n = N,
               min = 5,
               max = 10)
    
    err = rnorm(n = N,
                   mean = 15*20,
                   sd = 20*sqrt(30))
    X = data.frame(x1, x2, x3, x4, x5, x6)
    p = ncol(X)
    y =4*x1^2+2*x2^2*x3*exp(-abs(x4))+x6*(1.5*log(abs(x5)))-12*x5*log(abs(x6))+sin(x3^2)*log(x3^2) + sin(x3*x4-x5)-1/(exp(1/x4))+x2^2*x3^2-x3^2*x1^2*log(abs(x2-x5))+ sin(x4*x5^2) + err
  }
  
  
  
  if (mod == "f5"){
    x1 = runif(n=N, 
               min = -5,
               max = 5)
    x2 = runif(n=N, 
               min = 5,
               max = 10)
    x3 = runif(n=N, 
               min = -5,
               max = 5)
    x4 = runif(n=N, 
               min = 5,
               max = 10)
    
    x5 = runif(n = N,
               min = -5,
               max = 5)
    x6 = runif(n = N,
               min = 5,
               max = 10)

    
    err = rnorm(n = N,
                   mean = 15*50,
                   sd = 50*sqrt(30))
    X = data.frame(x1, x2, x3, x4, x5, x6)
    p = ncol(X)
    y =4*x1^2+2*x2^2*x3*exp(-abs(x4))+x6*(1.5*log(abs(x5)))-12*x5*log(abs(x6))+sin(x3^2)*log(x3^2) + sin(x3*x4-x5)-1/(exp(1/x4))+x2^2*x3^2-x3^2*x1^2*log(abs(x2-x5))+ sin(x4*x5^2) + err
  }
  

  
  set.seed(seed)
  
  pop = as.data.frame(cbind(X, y)) %>%
    mutate(class = ifelse(y < median(y), "0", "1") %>% as.factor() 
           
    ) %>%
    arrange(class)
  colnames(pop) = c(colnames(X), "y",  "realclass")
  
  mu = mean(pop$y)
  
  # MMIE code

  
  samp.f = function(samp, nA, nB, r, pop, p ){
    MMIE_code = function(A, B, b_model, novel.dat = A_or_B, N, method, p, normval){
      
      fx_gam_lm = paste0('ns(x', 1:p) %>%
        paste0(', df = 10)') %>%
        paste(collapse = '+') %>%
        reformulate('y')     
      
      fx_novel = paste0("x", 1:p) %>%
        paste(collapse = "+") %>% 
        reformulate("samp")
      fx_novel_nn = c(
        paste0("x", 1:p),
        'y') %>%
        paste(collapse = "+") %>% 
        
        reformulate("samp")
      
      fx_novel_gam = paste0("ns(x", 1:p) %>%
        paste0(', df=10)') %>% 
        paste(collapse = "+") %>%
        reformulate("samp")
      
      
      # matching step
      if(method == 'exact'){
        novel.match = matchit(fx_novel,
                              method = 'exact',
                              verbose = FALSE,
                              data = novel.dat)
        novel.df = match.data(novel.match) %>%
          filter(samp == 'B')   %>%  mutate(A_Prob = nA/N) %>%
          mutate(weight = 1/A_Prob)
      } else if(method == 'cem'){
        novel.match = matchit(fx_novel,
                              method = 'cem',
                              verbose = FALSE,
                              cutpoints = 'q5',
                              data = novel.dat)
        
        novel.df = match.data(novel.match) %>%
          filter(samp == "B")   %>%  mutate(A_Prob = nA/N) %>%
          mutate(weight = 1/A_Prob)
      } else if(method == 'nn'){
        novel.match = matchit(fx_novel_nn,
                              method = 'nearest',
                              distance = 'mahalanobis',
                              verbose = FALSE,
                              data = novel.dat)
        
        novel.df = match.data(novel.match) %>%
          filter(samp == "B")   %>%  mutate(A_Prob = nA/N) %>%
          mutate(weight = 1/A_Prob)
        
      } else if(method == 'cnn'){
        
        A_hat = novel.dat %>%
          filter(samp == 'A')
        
        match_ids = (1:nA) %>%
          sapply(FUN = function(x){which.min(abs(A_hat$y[x]-B$y))},
                 simplify = FALSE
          ) %>%
          unlist()
        
        novel.df = B[match_ids, ] %>%
          mutate(weight = N/nA)
        
      } else if(method == 'rnn'){
        
        
        A_hat = novel.dat %>%
          filter(samp == 'A')
        
        norm_A = (1:nA) %>%
          sapply(FUN = function(x){sqrt(sum(A_hat[x, c('y', paste0('x', 1:p))]^normval))})
            
        norm_B = (1:nB) %>%
          sapply(FUN = function(x){sqrt(sum(B[x, c('y', paste0('x', 1:p))]^normval))})
        
        match_ids = (1:nA) %>%
          sapply(FUN = function(x){which.min(abs(norm_A[x]-norm_B))},
                 simplify = FALSE
          ) %>%
          unlist()
        
        
        novel.df = B[match_ids, ] %>%
          mutate(weight = N/nA)
        
      } else{
        stop("Please insert a valid matching mechanism.")
      }
      
      # HAJ est
      assign(paste0("HAJ_", method),
             sum(novel.df$y * novel.df$weight) / sum(novel.df$weight))
      
      # MMIs
      
      gcvs = try(lm(fx_gam_lm, 
                    data = novel.df),
                 silent = TRUE)
      
   
      
      if(any(class(gcvs) == 'try-error')){
        assign(paste0("HAJ_", method, "_gcv"), NA)
      } else{
        assign(paste0("HAJ_", method, "_gcv"),
               sum(predict(gcvs, newdata = A)*A$weight) / sum(A$weight))
      }
      
      
      
      
      # FINAL
      
      MMIE_df = data.frame(get(paste0("HAJ_", method)),
                           get(paste0("HAJ_", method, "_gcv")))
      
      
      
      colnames(MMIE_df) = c(paste0('SM', method), 
                            paste0('MMI', method))
      
      
      
      return(MMIE_df)
    }
    
# generate a pair of datasets
    
sizes = nB*c(r, 1-r)

s.B = sampling::strata(pop, stratanames = "realclass", size = sizes, method = 'srswor')
B = getdata(pop, s.B)
  


s.A= sample(1:N, nA, replace=FALSE)
A = pop[s.A, ] %>%
  mutate(Prob = nA/N,
         weight = N/nA)


# sample means
mean.A = sum(A$y * A$weight) / N
mean.B = mean(B$y)

## NPMIEG

fx_gam_lm = paste0('ns(x', 1:p) %>%
  paste0(', df = 10)') %>%
  paste(collapse = '+') %>%
  reformulate('y') 
fx_gam = paste0('s(x', 1:p) %>%
  paste0(')') %>%
  paste(collapse = '+') %>%
  reformulate('y')
    
B.gcv = lm(fx_gam_lm,
         data = B) # has nearly identical results with mgcv::gam, and is faster
    
predlars_A =if( any(class(B.gcv) == "try-error")){NA} else{predict(B.gcv, newdata=A %>% dplyr::select(paste0("x",
                                                                                                                 1:p)))}
predlars_B = if( any(class(B.gcv) == "try-error")){NA} else{predict(B.gcv, newdata=B %>% dplyr::select(paste0("x",
                                                                                                                1:p)))}
GAM = (1/nrow(pop))*sum(predlars_A*A$weight)
     
varhat_GAM = if( any(class(B.gcv) == "try-error")){NA} else{((1 - nA/N)/nA) * (var(predict(B.gcv, newdata = A)))}

# # # DR - GAM - GAM

#  Sampling Setup
A.r = A %>%
  dplyr::select(-c(Prob, realclass)) %>%
  mutate(y = predlars_A) %>%
  dplyr::select(paste0('x', 1:p), 'y', 'weight')


B.r = B %>%
  dplyr::select(paste0("x", 1:p), y) %>%
  mutate(weight = NA)

A_or_B = union(A.r, B.r) %>%
  mutate(samp = rep(c('A','B'), c(nA, nB)))

# Score function 
t0 = rep(0, times = p) %>% matrix() # initial
U.theta = function(A.r, B.r, t.m){
  A.r = A.r %>%
    dplyr::select(paste0('x', 1:p), everything())
  
  B.r = B.r %>%
    dplyr::select(paste0('x', 1:p), everything())
  
 B.xi_trans = as.matrix(B.r[1:nB, 1:p])  
 A.xi_trans = as.matrix(A.r[1:nA, 1:p])
 num_pi = exp(A.xi_trans%*%t.m)
 dem_pi = (1+exp(A.xi_trans%*%t.m))
hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)

  p1 =  (1:nB) %>%
    sapply(FUN = function(x){
      matrix(B.xi_trans[x, 1:p], 
             nrow = p,
             ncol = 1)
    }, simplify =FALSE)  %>%
    Reduce(x=., '+')
  p2 =  (1:nA) %>%
  sapply(FUN = function(x){
    (A.r$weight[x]*hatpi[x])* matrix(A.xi_trans[x, 1:p], 
                                       nrow = p,
                                       ncol = 1)
    }
    , simplify = FALSE) %>%
    Reduce(x=., '+')
  
  return(p1 - p2)
}
H.theta = function(A.r, B.r, t.m){
  A.r = A.r %>%
    dplyr::select(paste0('x', 1:p), everything())
  
  
  A.xi_trans = as.matrix(A.r[1:nA, 1:p])
  num_pi = exp(A.xi_trans%*%t.m)
  dem_pi = (1+exp(A.xi_trans%*%t.m))
  hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
  p2 =  (1:nA) %>%
    sapply(FUN = function(x){(A.r$weight[x]*hatpi[x]*(1-hatpi[x]))*
        matrix(A.xi_trans[x, 1:p], nrow =p, ncol =1) %*%
        matrix(A.xi_trans[x, 1:p], nrow =1, ncol =p)
      }, simplify =FALSE) %>%
    Reduce(x=., '+')
  
  return(p2)
  
}
score_func = function(A.r, B.r, t.m){
  return(t.m + solve(H.theta(A.r, B.r, t.m))%*%U.theta(A.r, B.r, t.m))
}

# Solving Score function
tol = 1e-06 
max_iter = 300
solve_score = function(A.r, B.r, t0, tol, max_iter){
  U.theta = function(A.r, B.r, t.m){
    A.r = A.r %>%
      dplyr::select(paste0('x', 1:p), everything())
    
    B.r = B.r %>%
      dplyr::select(paste0('x', 1:p), everything())
    
    B.xi_trans = as.matrix(B.r[1:nB, 1:p])  
    A.xi_trans = as.matrix(A.r[1:nA, 1:p])
    num_pi = exp(A.xi_trans%*%t.m)
    dem_pi = (1+exp(A.xi_trans%*%t.m))
    hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
    
    p1 =  (1:nB) %>%
      sapply(FUN = function(x){
        matrix(B.xi_trans[x, 1:p], 
               nrow = p,
               ncol = 1)
      }, simplify =FALSE)  %>%
      Reduce(x=., '+')
    p2 =  (1:nA) %>%
      sapply(FUN = function(x){
        (A.r$weight[x]*hatpi[x])* matrix(A.xi_trans[x, 1:p], 
                                         nrow = p,
                                         ncol = 1)
      }
      , simplify = FALSE) %>%
      Reduce(x=., '+')
    
    return(p1 - p2)
  }
  H.theta = function(A.r, B.r, t.m){
    A.r = A.r %>%
      dplyr::select(paste0('x', 1:p), everything())
    
    
    A.xi_trans = as.matrix(A.r[1:nA, 1:p])
    num_pi = exp(A.xi_trans%*%t.m)
    dem_pi = (1+exp(A.xi_trans%*%t.m))
    hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
    p2 =  (1:nA) %>%
      sapply(FUN = function(x){(A.r$weight[x]*hatpi[x]*(1-hatpi[x]))*
          matrix(A.xi_trans[x, 1:p], nrow =p, ncol =1) %*%
          matrix(A.xi_trans[x, 1:p], nrow =1, ncol =p)
      }, simplify =FALSE) %>%
      Reduce(x=., '+')
    
    return(p2)
    
  }
  score_func = function(A.r, B.r, t.m){
    return(t.m + solve(H.theta(A.r, B.r, t.m))%*%U.theta(A.r, B.r, t.m))
  }
  
th = rep(list(NULL), max_iter)
for(i in 1:max_iter){
  if(i == 1){
    th[[i]] = t0 + solve(H.theta(A.r, B.r, t0))%*%U.theta(A.r, B.r, t0)
  } else{
    th[[i]] = th[[i-1]] +
      solve(H.theta(A.r, B.r, th[[i-1]]))%*%U.theta(A.r, B.r, th[[i-1]])
    
    e_dist = dist(rbind(as.numeric(th[[i]]),
                        as.numeric(th[[i-1]])))
    if(e_dist <= tol){
      break
      }
  }
  }

th_final = 
(th %>% purrr::discard(is.null))[i] %>%
  unlist() %>%
  matrix(nrow = p, ncol =1)

return(th_final)
}
th_final = try(solve_score(A.r,
            B.r,
            t0,
            tol,
            max_iter), silent = TRUE)

if(any(class(th_final) == 'try-error')){
  prop_mean = NA
  DR_mean = NA
} else{

B = B %>%
  mutate(est_probs = exp(as.matrix(B.r[, 1:p])%*%th_final)/
           (1+exp(as.matrix(B.r[, 1:p])%*%th_final))) %>%
  mutate(est_weights = 1/est_probs)

prop_mean = sum(B$y*B$est_weights)/sum(B$est_weights)
DR_mean = (1/sum(B$est_weights))*sum(B$est_weights * (B$y - predlars_B)) +
  (1/sum(A$weight))*sum(A$weight*predlars_A) 

}

# Statistical Matching

MMIE2_exact = MMIE_code(A = A,
                    B = B,
                    p = p,
                    N = N,
                    novel.dat = A_or_B,
                  method = 'exact')

MMIE2_cem= MMIE_code(A = A,
                        B = B,
                        p = p,
                        N = N,
                        novel.dat = A_or_B,
                        method = 'cem')
MMIE2_cnn = MMIE_code(A = A,
                       B = B,
                       p = p,
                       N = N,
                       b_model = B.gcv,
                       novel.dat = A_or_B,
                       method = 'cnn')

MMIE2_rnn = MMIE_code(A = A,
                       B = B,
                       p = p,
                       b_model = B.gcv,
                       N = N,
                       novel.dat = A_or_B,
                       normval = 2,
                       method = 'rnn')


MMIE = cbind(MMIE2_exact[1:2],
             MMIE2_cem[1:2],
             MMIE2_cnn[1:2],
             MMIE2_rnn[1:2])

final_dat = cbind(mu,
                      mean.A,
                      mean.B,
                      GAM,
                      varhat_GAM,
                      prop_mean,
                      DR_mean, 
                      MMIE) %>%
      data.frame() %>%
      mutate(nA = nA,
             nB = nB,
             r= r,
             nsim = nsim) %>%
      dplyr::select(nsim, nA, nB, r,  mu, 
                    mean.A,
                    mean.B,
                    GAM,
                    prop_mean,
                    DR_mean,
                    paste0('SM', c('exact', 'cem', 'cnn', 'rnn')),
                    paste0('MMI', c('exact', 'cem', 'cnn', 'rnn'))) 

  return(final_dat)
  }
  
  iter = 1:nsim
  set.seed(seed)
  
  
  results_r = results_r_nB = c()
  for(i in 1:length(nB)){
    for(j in 1:length(r)){
      results_r[[j]] = pbmclapply(X = iter,  r = r[j],
                                   nB = nB[i], 
                                   nA = nA,
                                   pop = pop,
                                   p =p, 
                                   FUN = samp.f, 
                                   mc.cores = 17)
      
    }
    results_r_nB[[i]] = bind_rows(results_r, .id = 'iter')
    
    progress(i, length(nB))
  }
  
  
  results = results_r_nB %>%
    bind_rows(.id = 'iter')
  
  
all_results =
  results %>% 
    dplyr::select(-c('iter', contains("varhat"))) %>%
    dplyr::select(nA, nB, r, mean.A, mu, everything()) %>%
    pivot_longer(cols = 7:ncol(.)) %>%
    group_by(nB, r,name) %>%
    mutate(rmse_A = sqrt(mean((mean.A - mu)^2)),
           bias_A =mean(mean.A - mu),
           var_A = var(mean.A)) %>%
    dplyr::select(nA, nB, r, mu, rmse_A, bias_A, var_A, name, value) %>%
    group_by(nB, r, name) %>%
    dplyr::summarize(rrmse = sqrt(mean((value - mu)^2, na.rm = TRUE))/mean(rmse_A),
                     rbias = mean(value - mu, na.rm = TRUE)/mean(bias_A),
                     rvar = var(value, na.rm = TRUE) ) %>%
    mutate(nA = nA, nB =nB, r =r, mod = mod) %>%
    dplyr::select(mod, nA, nB, r, everything())

  
  return(all_results)
  
  
}

# example run
nsim = 1000
N = 100000
nA = .01*N
nB = c(nA/N, .10, .20)*N
seed=101
r = c(.50, .30, .15, .05,  .01)


setwd("/Users/jeremyflood/OneDrive/Documents/Grad School/2024-2025/Spring 2025/MMIE Revisions/MC Code")

# f1
mod = 'f1'
f1_model = sim.f2(N = N,
                  nA = nA,
                  nB = nB,
                  nsim = nsim,
                  mod = 'f1',
                  seed = 101,
                  r = r)

f1_model %>%
openxlsx::write.xlsx('modf1_results.xlsx')

# f2
mod = 'f2'
f2_model = sim.f2(N = N,
                  nA = nA,
                  nB = nB,
                  nsim = nsim,
                  mod = 'f2',
                  seed = 101,
                  r = r)

f2_model %>%
  openxlsx::write.xlsx('modf2_results.xlsx')

# f3
mod = 'f3'
f3_model = sim.f2(N = N,
                  nA = nA,
                  nB = nB,
                  nsim = nsim,
                  mod = 'f3',
                  seed = 101,
                  r = r)

f3_model %>%
  openxlsx::write.xlsx('modf3_results.xlsx')

# f4
mod = 'f4'
f4_model = sim.f2(N = N,
                  nA = nA,
                  nB = nB,
                  nsim = nsim,
                  mod = 'f4',
                  seed = 101,
                  r = r)

f4_model %>%
  openxlsx::write.xlsx('modf4_results.xlsx')


# f5
mod = 'f5'
f5_model = sim.f2(N = N,
                  nA = nA,
                  nB = nB,
                  nsim = nsim,
                  mod = 'f5',
                  seed = 101,
                  r = r)

f5_model %>%
  openxlsx::write.xlsx('modf5_results.xlsx')
  

# pooling recorded results
setwd("/Users/jeremyflood/Library/CloudStorage/OneDrive-Personal/Documents/Grad School/2024-2025/Spring 2025/MMIE Revisions/MC Code")
mods = paste0('modf', 1:5) %>%
  paste0('_results.xlsx')

df_together = c()

for(i in 1:length(mods)){
df_together[[i]] = openxlsx::read.xlsx(mods[i])
}

# Figures
## RRMSE
df_together %>%
  bind_rows() %>%
  mutate(rrmse = ifelse(name %in% c('MMIexact', 'MMIcem') & nB == 1000, NA, rrmse )) %>%
  mutate(mod = factor(mod,
                      labels= c('f1' = TeX("Model $\\xi_{1}"),
                                'f2' = TeX("Model $\\xi_{2}"),
                                'f3' = TeX("Model $\\xi_{3}"),
                                'f4' = TeX("Model $\\xi_{4}"),
                                'f5' =  TeX("Model $\\xi_{5}"))),
         nB = factor(nB,
                     labels = c('1000' = TeX("$n_B = n_A$"), '10000' = TeX("$n_B = 10n_A$"), '20000' = TeX("$n_B = 20n_A$"))))%>%
  filter(name != 'prop_mean') %>%
  mutate(name = ifelse(name == 'MMIcnn', 'MMIunn',
                       ifelse(name == 'SMcnn', 'SMunn',
                          ifelse(name == 'DR_mean', 'DRgam',
                              ifelse(name == 'mean.B', 'B', name))))) %>%
  mutate(name = factor(name, levels = c('MMIrnn', 'MMIunn', "SMrnn", "SMunn",  "DRgam", "GAM", "SMcem",
                                        "SMexact", "B", "MMIcem","MMIexact"
  ))) %>%
  dplyr::select(-rvar) %>%
  dplyr::select(-rbias) %>%
  mutate(r = as.factor(r)) %>%
  ggplot(aes(x=name, y = rrmse^(1/2), color = r, group = r)) + 
  geom_line(linewidth = .5) +
  geom_point(size = 1) +
  facet_grid(scales ='free', rows = dplyr::vars(nB), cols = dplyr::vars(mod),
             labeller = label_parsed) +
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1, face = 'bold'),
        legend.position = 'top') +
  ylab(TeX("$\\sqrt{RRMSE}")) +
  xlab('Estimator')


## ARBR
df_together %>% 
  bind_rows() %>%
  mutate(rbias = ifelse(name %in% c('MMIexact', 'MMIcem') & nB == 1000, NA, rbias )) %>%
  mutate(mod = factor(mod, 
                      labels= c('f1' = TeX("Model $\\xi_{1}"), 
                                'f2' = TeX("Model $\\xi_{2}"), 
                                'f3' = TeX("Model $\\xi_{3}"),
                                'f4' = TeX("Model $\\xi_{4}"), 
                                'f5' =  TeX("Model $\\xi_{5}"))),
         nB = factor(nB,
                     labels = c('1000' = TeX("$n_B = n_A$"), '10000' = TeX("$n_B = 10n_A$"), '20000' = TeX("$n_B = 20n_A$"))))%>%
  filter(name != 'prop_mean') %>%
  mutate(name = ifelse(name == 'MMIcnn', 'MMIunn',
                       ifelse(name == 'SMcnn', 'SMunn',
                              ifelse(name == 'DR_mean', 'DRgam',
                                     ifelse(name == 'mean.B', 'B', name))))) %>%
  mutate(name = factor(name, levels = c('MMIrnn', 'MMIunn', "SMrnn", "SMunn",  "DRgam", "GAM", "SMcem",
                                        "SMexact", "B", "MMIcem","MMIexact"
  ))) %>%
  dplyr::select(-rvar) %>%
  dplyr::select(-rrmse) %>%
  mutate(r = as.factor(r)) %>%
  ggplot(aes(x=name, y = rbias/100, color = r, group = r)) + 
  geom_line(linewidth = .5) +
  geom_point(size = 1) +
  facet_grid(scales ='free', rows = dplyr::vars(nB), cols = dplyr::vars(mod),
             labeller = label_parsed) + 
  theme(axis.text.x = element_text(angle = 90, vjust = 0.5, hjust=1, face = 'bold'),
        legend.position = 'top') + 
  ylab(TeX("$\\frac{ARBR}{100}")) +
  xlab('Estimator')


# Tables

## RRMSE
final_rrmse = df_together %>% 
  bind_rows() %>%
  dplyr::select(-c('rbias', 'rvar')) %>%
  dplyr::select(mod, nA, nB, r, everything()) %>%
  mutate(rrmse = round(rrmse, digits = 2)) %>%
  pivot_wider(values_from = 'rrmse') %>%
  arrange(mod, nB, -r) %>%
  dplyr::select(mod, nA, nB, r, mean.B, 
                GAM, DR_mean, 
                paste0('SM', c('exact', 'cem', 'cnn', 'rnn')),
                paste0('MMI', c('exact', 'cem', 'cnn', 'rnn'))
  ) %>%
  group_split(nB) %>%
  as.list() %>%
  setNames(paste0('nB=', c(.01, .10, .20), 'N'))


final_rrmse

## ARBR
which_min_rbias = df_together %>% 
  bind_rows() %>%
  dplyr::select(-c('rrmse', 'rvar')) %>%
  dplyr::select(mod, nA, nB, r, everything()) %>%
  mutate(rbias = round(rbias, digits = 2)) %>%
  group_by(mod, nB, r) %>%
  dplyr::slice(which.min(abs(rbias))) %>%
  dplyr::select(mod, nB, r, name)


final_rbias =df_together %>% 
  bind_rows() %>%
  dplyr::select(-c('rrmse', 'rvar')) %>%
  dplyr::select(mod, nA, nB, r, everything()) %>%
  mutate(rbias = round(abs(rbias), digits = 2)) %>%
  pivot_wider(values_from = 'rbias') %>%
  arrange(mod,nB,-r) %>%
  dplyr::select(mod, nA, nB, r, mean.B, 
                GAM, DR_mean, 
                paste0('SM', c('exact', 'cem', 'cnn', 'rnn')),
                paste0('MMI', c('exact', 'cem', 'cnn', 'rnn'))
  ) %>%
  group_split(nB) %>%
  as.list() %>%
  setNames(paste0('nB=', c(.01, .10, .20), 'N'))

final_rrmse %>%
  openxlsx::write.xlsx('final_rrmse.xlsx')

final_rbias %>%
  openxlsx::write.xlsx('final_rbias.xlsx')


