require(tidyverse)
require(tidyr)
require(ggpmisc)
require(svMisc)
require(CBPS)
require(geiger)
require(lsa)
require(DescTools)
require(MVTests)
require(caret)
require(dbarts)
require(parallel)
require(gbm)
require(pbmcapply)
require(extraDistr)
require(plyr)
require(data.table)
RNGkind("L'Ecuyer-CMRG")
require(schoenberg)
require(lsr)
require(car)
require(psych)
require(quickmatch)
require(devtools)
require(Matching)
require(rgenoud)
require(optmatch)
require(Hmisc)
require(rio)
require(sjstats)
require(schoolmath)
require(MatchIt)
require(magrittr)
require(xlsx)
require(writexl)
require(ncvreg)
require(np)
require(dplyr)
require(tidyverse)
require(survey)
require(sampling)
require(KernSmooth)
require(caTools)
require(gridExtra)
require(lars)
require(glmnet)
require(Metrics)
Sample=Vectorize(sample)
Dat = function(x, p, size, seed){
  set.seed(seed)
  return(x[x$part==p,][sample(nrow(x[x$part==p,]), size),])
}
Dat.v = Vectorize(Dat, vectorize.args=c("size", "p"))
require(MASS)
require(mgcv) 
require(parallel)
require(ranger)
require(xgboost)
library(dplyr)
library(mgcv)
library(tidymv)
require(haven)
`%notin%` <- Negate(`%in%`)

require(survey)
require(svrep)
require(svMisc)
require(doParallel)
require(splines)
require(future.apply)
require(pbapply)
require(mcreplicate)


    
  nsim = 500
  N = 100000
  nA = .01*N
  nB = c(.20)*N
  seed=101
  r = c(.50, .30, .15)
  mod = 'f1'
  
  if (mod == "f1"){
    set.seed(seed)
    x1 = rnorm(N, mean = 2, sd = 1)
    x2 = rnorm(N, mean = 2, sd = 1)
    x3 = rnorm(N, mean = 4, sd = 1)
    x4 = rnorm(N, mean = 4, sd = 1)
    y = rnorm(N, 4*x1+4*x2 + 2*x3 + 2*x4, 3)
    
    X=cbind(x1, x2, x3, x4)
    p = ncol(X)
    
  }
  
  pop = as.data.frame(cbind(X, y)) %>%
    mutate(class = ifelse(y < median(y), "0", "1") %>% as.factor() 
           
    ) %>%
    arrange(class)
  colnames(pop) = c(colnames(X), "y",  "realclass")
  
  mu = mean(pop$y)
  
  MMIE_code = function(A, B, b_model, novel.dat = A_or_B, N, method, p, normval){
    
    fx_gam_lm = paste0('ns(x', 1:p) %>%
      paste0(', df = 10)') %>%
      paste(collapse = '+') %>%
      reformulate('y')     
    
    fx_novel = paste0("x", 1:p) %>%
      paste(collapse = "+") %>% 
      reformulate("samp")
    fx_novel_nn = c(
      paste0("x", 1:p),
      'y') %>%
      paste(collapse = "+") %>% 
      
      reformulate("samp")
    
    fx_novel_gam = paste0("ns(x", 1:p) %>%
      paste0(', df=10)') %>% 
      paste(collapse = "+") %>%
      reformulate("samp")
    
    
    # matching step
    if(method == 'exact'){
      novel.match = matchit(fx_novel,
                            method = 'exact',
                            verbose = FALSE,
                            data = novel.dat)
      novel.df = match.data(novel.match) %>%
        filter(samp == 'B')   %>%  mutate(A_Prob = nA/N) %>%
        mutate(weight = 1/A_Prob)
    } else if(method == 'cem'){
      novel.match = matchit(fx_novel,
                            method = 'cem',
                            verbose = FALSE,
                            cutpoints = 'q5',
                            data = novel.dat)
      
      novel.df = match.data(novel.match) %>%
        filter(samp == "B")   %>%  mutate(A_Prob = nA/N) %>%
        mutate(weight = 1/A_Prob)
    } else if(method == 'nn'){
      novel.match = matchit(fx_novel_nn,
                            method = 'nearest',
                            distance = 'mahalanobis',
                            verbose = FALSE,
                            data = novel.dat)
      
      novel.df = match.data(novel.match) %>%
        filter(samp == "B")   %>%  mutate(A_Prob = nA/N) %>%
        mutate(weight = 1/A_Prob)
      
    } else if(method == 'unn'){
      
      A_hat = novel.dat %>%
        filter(samp == 'A')
      
      match_ids = (1:nA) %>%
        sapply(FUN = function(x){which.min(abs(A_hat$y[x]-B$y))},
               simplify = FALSE
        ) %>%
        unlist()
      
      novel.df = B[match_ids, ] %>%
        mutate(weight = N/nA)
      
    } else if(method == 'rnn'){
      
      
      A_hat = novel.dat %>%
        filter(samp == 'A')
      
      norm_A = (1:nA) %>%
        sapply(FUN = function(x){sqrt(sum(A_hat[x, c('y', paste0('x', 1:p))]^normval))})
      
      norm_B = B %>% rowwise() %>%
        mutate(norm = sqrt(y^2+x1^2+x2^2+x3^2+x4^2)) %>% dplyr::select(norm) %>%
        unlist() %>% as.numeric() 
  
      
      match_ids = (1:nA) %>%
        sapply(FUN = function(x){which.min(abs(norm_A[x]-norm_B))},
               simplify = FALSE
        ) %>%
        unlist()
      
      
      novel.df = B[match_ids, ] %>%
        mutate(weight = N/nA)
      
    } else{
      stop("Please insert a valid matching mechanism.")
    }
    
    # HAJ est
    assign(paste0("HAJ_", method),
           sum(novel.df$y * novel.df$weight) / sum(novel.df$weight))
    
    # MMIs
    
    gcvs = try(lm(fx_gam_lm, 
                  data = novel.df),
               silent = TRUE)
    
    
    
    if(any(class(gcvs) == 'try-error')){
      assign(paste0("HAJ_", method, "_gcv"), NA)
    } else{
      assign(paste0("HAJ_", method, "_gcv"),
             sum(predict(gcvs, newdata = A)*A$weight) / sum(A$weight))
    }
    
    
    
    
    # FINAL
    
    MMIE_df = data.frame(get(paste0("HAJ_", method)),
                         get(paste0("HAJ_", method, "_gcv")))
    
    
    
    colnames(MMIE_df) = c(paste0('SM', method), 
                          paste0('MMI', method))
    
    
    
    return(MMIE_df)
  }
  
  application = function(N,
                         A,
                         B,
                         pop,
                         p, r){
  
    
    # sample means
    mean.A = sum(A$y * A$weight) / N
    mean.B = mean(B$y)
    
    ## NPMIEG
    
    fx_gam_lm = paste0('ns(x', 1:p) %>%
      paste0(', df = 10)') %>%
      paste(collapse = '+') %>%
      reformulate('y') 
    fx_gam = paste0('s(x', 1:p) %>%
      paste0(')') %>%
      paste(collapse = '+') %>%
      reformulate('y')
    
    B.gcv = try(lm(fx_gam_lm,
                   data = B), silent = TRUE) # has nearly identical results with mgcv::gam, and is faster
    
    predlars_A =if( any(class(B.gcv) == "try-error")){NA} else{predict(B.gcv, newdata=A %>% dplyr::select(paste0("x",
                                                                                                                 1:p)))}
    predlars_B = if( any(class(B.gcv) == "try-error")){NA} else{predict(B.gcv, newdata=B %>% dplyr::select(paste0("x",
                                                                                                                  1:p)))}
    GAM = (1/nrow(pop))*sum(predlars_A*A$weight)
    
    
    # # # DR - GAM - GAM
    
    #  Sampling Setup
    A.r = A %>%
      dplyr::select(-c(Prob, realclass)) %>%
      mutate(y = predlars_A) %>%
      dplyr::select(paste0('x', 1:p), 'y', 'weight')
    
    B.r = B %>%
      dplyr::select(paste0("x", 1:p), y) %>%
      mutate(weight = NA)
    
    A_or_B = dplyr::union_all(A.r, B.r) %>%
      mutate(samp = rep(c('A','B'), c(nA, nB)))
    
    # Score function 
    t0 = rep(0, times = p) %>% matrix() # initial
    U.theta = function(A.r, B.r, t.m){
      A.r = A.r %>%
        dplyr::select(paste0('x', 1:p), everything())
      
      B.r = B.r %>%
        dplyr::select(paste0('x', 1:p), everything())
      
      B.xi_trans = as.matrix(B.r[1:nB, 1:p])  
      A.xi_trans = as.matrix(A.r[1:nA, 1:p])
      num_pi = exp(A.xi_trans%*%t.m)
      dem_pi = (1+exp(A.xi_trans%*%t.m))
      hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
      
      p1 =  (1:nB) %>%
        sapply(FUN = function(x){
          matrix(B.xi_trans[x, 1:p], 
                 nrow = p,
                 ncol = 1)
        }, simplify =FALSE)  %>%
        Reduce(x=., '+')
      p2 =  (1:nA) %>%
        sapply(FUN = function(x){
          (A.r$weight[x]*hatpi[x])* matrix(A.xi_trans[x, 1:p], 
                                           nrow = p,
                                           ncol = 1)
        }
        , simplify = FALSE) %>%
        Reduce(x=., '+')
      
      return(p1 - p2)
    }
    H.theta = function(A.r, B.r, t.m){
      A.r = A.r %>%
        dplyr::select(paste0('x', 1:p), everything())
      
      
      A.xi_trans = as.matrix(A.r[1:nA, 1:p])
      num_pi = exp(A.xi_trans%*%t.m)
      dem_pi = (1+exp(A.xi_trans%*%t.m))
      hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
      p2 =  (1:nA) %>%
        sapply(FUN = function(x){(A.r$weight[x]*hatpi[x]*(1-hatpi[x]))*
            matrix(A.xi_trans[x, 1:p], nrow =p, ncol =1) %*%
            matrix(A.xi_trans[x, 1:p], nrow =1, ncol =p)
        }, simplify =FALSE) %>%
        Reduce(x=., '+')
      
      return(p2)
      
    }
    score_func = function(A.r, B.r, t.m){
      return(t.m + solve(H.theta(A.r, B.r, t.m))%*%U.theta(A.r, B.r, t.m))
    }
    
    # Solving Score function
    tol = 1e-06 
    max_iter = 300
    solve_score = function(A.r, B.r, t0, tol, max_iter){
      U.theta = function(A.r, B.r, t.m){
        A.r = A.r %>%
          dplyr::select(paste0('x', 1:p), everything())
        
        B.r = B.r %>%
          dplyr::select(paste0('x', 1:p), everything())
        
        B.xi_trans = as.matrix(B.r[1:nB, 1:p])  
        A.xi_trans = as.matrix(A.r[1:nA, 1:p])
        num_pi = exp(A.xi_trans%*%t.m)
        dem_pi = (1+exp(A.xi_trans%*%t.m))
        hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
        
        p1 =  (1:nB) %>%
          sapply(FUN = function(x){
            matrix(B.xi_trans[x, 1:p], 
                   nrow = p,
                   ncol = 1)
          }, simplify =FALSE)  %>%
          Reduce(x=., '+')
        p2 =  (1:nA) %>%
          sapply(FUN = function(x){
            (A.r$weight[x]*hatpi[x])* matrix(A.xi_trans[x, 1:p], 
                                             nrow = p,
                                             ncol = 1)
          }
          , simplify = FALSE) %>%
          Reduce(x=., '+')
        
        return(p1 - p2)
      }
      H.theta = function(A.r, B.r, t.m){
        A.r = A.r %>%
          dplyr::select(paste0('x', 1:p), everything())
        
        
        A.xi_trans = as.matrix(A.r[1:nA, 1:p])
        num_pi = exp(A.xi_trans%*%t.m)
        dem_pi = (1+exp(A.xi_trans%*%t.m))
        hatpi = ifelse(num_pi == Inf & dem_pi == Inf, 1, num_pi/dem_pi)
        p2 =  (1:nA) %>%
          sapply(FUN = function(x){(A.r$weight[x]*hatpi[x]*(1-hatpi[x]))*
              matrix(A.xi_trans[x, 1:p], nrow =p, ncol =1) %*%
              matrix(A.xi_trans[x, 1:p], nrow =1, ncol =p)
          }, simplify =FALSE) %>%
          Reduce(x=., '+')
        
        return(p2)
        
      }
      score_func = function(A.r, B.r, t.m){
        return(t.m + solve(H.theta(A.r, B.r, t.m))%*%U.theta(A.r, B.r, t.m))
      }
      
      th = rep(list(NULL), max_iter)
      for(i in 1:max_iter){
        if(i == 1){
          th[[i]] = t0 + solve(H.theta(A.r, B.r, t0))%*%U.theta(A.r, B.r, t0)
        } else{
          th[[i]] = th[[i-1]] +
            solve(H.theta(A.r, B.r, th[[i-1]]))%*%U.theta(A.r, B.r, th[[i-1]])
          
          e_dist = dist(rbind(as.numeric(th[[i]]),
                              as.numeric(th[[i-1]])))
          if(e_dist <= tol){
            break
          }
        }
      }
      
      th_final = 
        (th %>% purrr::discard(is.null))[i] %>%
        unlist() %>%
        matrix(nrow = p, ncol =1)
      
      return(th_final)
    }
    th_final = try(solve_score(A.r,
                               B.r,
                               t0,
                               tol,
                               max_iter), silent = TRUE)
    
    if(any(class(th_final) == 'try-error')){
      prop_mean = NA
      DR_mean = NA
    } else{
      
      B = B %>%
        mutate(est_probs = exp(as.matrix(B.r[, 1:p])%*%th_final)/
                 (1+exp(as.matrix(B.r[, 1:p])%*%th_final))) %>%
        mutate(est_weights = 1/est_probs)
      
      prop_mean = sum(B$y*B$est_weights)/sum(B$est_weights)
      DR_mean = (1/sum(B$est_weights))*sum(B$est_weights * (B$y - predlars_B)) +
        (1/sum(A$weight))*sum(A$weight*predlars_A) 
      
    }
    
    MMIE2_exact = MMIE_code(A = A,
                            B = B,
                            p = p,
                            N = N,
                            novel.dat = A_or_B,
                            method = 'exact')
    
    MMIE2_cem= MMIE_code(A = A,
                         B = B,
                         p = p,
                         N = N,
                         novel.dat = A_or_B,
                         method = 'cem')
    MMIE2_unn = MMIE_code(A = A,
                          B = B,
                          p = p,
                          N = N,
                          b_model = B.gcv,
                          novel.dat = A_or_B,
                          method = 'unn')
    
    MMIE2_rnn = MMIE_code(A = A,
                          B = B,
                          p = p,
                          b_model = B.gcv,
                          N = N,
                          novel.dat = A_or_B,
                          normval = 2,
                          method = 'rnn')
    
    
    MMIE = cbind(MMIE2_exact[1:2],
                 MMIE2_cem[1:2],
                 MMIE2_unn[1:2],
                 MMIE2_rnn[1:2])
    
    final_dat = cbind(mu,
                      mean.A,
                      mean.B,
                      GAM,
                      varhat_GAM,
                      prop_mean,
                      DR_mean, 
                      MMIE) %>%
      data.frame() %>%
      mutate(nA = nA,
             nB = nB,
             r= r,
             nsim = nsim) %>%
      dplyr::select(nsim, nA, nB, r,  mu, 
                    mean.A,
                    mean.B,
                    GAM,
                    prop_mean,
                    DR_mean,
                    paste0('SM', c('exact', 'cem', 'unn', 'rnn')),
                    paste0('MMI', c('exact', 'cem', 'unn', 'rnn'))) 
    
    return(final_dat)
    
    
  }

  boot_func = function(samp, N, nB, r, pop, p, L = 500){
    
   
    N = nrow(pop)
    
    # MMIE code
    
    
    s.A_perm= sample(1:N, nA, replace=FALSE)
    A_perm= pop[s.A_perm, ] %>%
      mutate(weight = N/nA,
             Prob = nA/N,
             fpc = nA/N)
    
    mydesign = svydesign(ids = ~0,
                         weights = ~weight,
                         fpc = ~fpc,
                         data = A_perm)
    
    
    bootstrap_rep_design = as_bootstrap_design(mydesign,
                                               type = "Rao-Wu-Yue-Beaumont",
                                               replicates = L,
                                               samp_method_by_stage = 'SRSWOR')
    
    A_repweights_perm = as_data_frame_with_weights(bootstrap_rep_design,
                                                   full_wgt_name = "FULL_SAMPLE_WGT",
                                                   rep_wgt_prefix = "REP_WGT_"  )  %>%
      dplyr::select(-weight)
    A_list =c()
    for(i in 1:L){
      A_list[[i]] = A_repweights_perm %>% dplyr::select(y, paste0("x", 1:p), paste0("REP_WGT_", i), Prob, realclass) %>%
        dplyr::rename(weight = paste0("REP_WGT_", i))
    }
    
    # selecting B
    
    
    sizes = nB*c(r, 1-r)
    
    s.B = sampling::strata(pop, stratanames = "realclass", size = sizes, method = 'srswor')
    B_perm= getdata(pop, s.B)
    
    B_list =mc_replicate(L, list(B_perm[sample(1:nB, size = nB, replace = TRUE),]), mc.cores = 10)
    
    
    actual =  application(N = N,
                          A = A_perm,
                          B = B_perm,
                          p = p,
                          pop = pop, 
                          r = r) %>% bind_rows()

    
    results = mcmapply(N = N,
                     A = A_list,
                     B = B_list,
                     MoreArgs = list(p = p,
                                     pop = pop,
                                     r= r),
                     FUN =application, SIMPLIFY = FALSE,  mc.cores = 15) %>%
      bind_rows()
    
    actual_df = actual %>%
      dplyr::select(r, nA, nB, mu, mean.A, everything()) %>%
      pivot_longer(cols = 7:ncol(.), values_to = 'mean') %>%
      dplyr::select(name, mean)
    
   boot_var =  results %>%
      dplyr::select(r, nA, nB, mu, mean.A, everything()) %>%
      pivot_longer(cols = 7:ncol(.)) %>%
      left_join(actual_df, by = 'name') %>%
      group_by(name) %>%
      dplyr::summarize(boot_var = (1/L)*sum((value - mean)^2)) 
   
   final_dataset = boot_var %>%
     left_join(actual_df, by = 'name')
  
    return(final_dataset)
  }
  
  mu = mean(pop$y)
  iter = 1:nsim
  RNGkind("L'Ecuyer-CMRG")
  set.seed(NULL)
  
  
  # model f1

  f1_results_r = c()

  
  
  setwd('/Users/jeremyflood/Library/CloudStorage/OneDrive-Personal/Documents/Grad School/2024-2025/Spring 2025/MMIE Revisions/Bootstrap Results')
  
  
  
  for(j in 1:length(r)){
    f1_results_r[[j]] =  pblapply(iter, FUN = boot_func, L = 500, r = r[j], nB = nB, pop = pop, p =p) %>%
      lapply(mutate, r = r[j], mod = 'f1')
    f1_results_r[[j]] %>% bind_rows(.id = 'iter') %>% openxlsx::write.xlsx(paste0('f1_boot_', r[j]*100, '.xlsx'))
  }

  # read data in
  files = paste0('f1_boot_', r*100, '.xlsx')
  f1_results = c()
  for (i in 1:length(files)){
    f1_results[[i]] = openxlsx::read.xlsx(files[i])
  }
  
  MC_var = f1_results %>% 
    bind_rows() %>%
    group_by(mod, r, name) %>%
    dplyr::summarize(MC_var = var(mean))

  
  est_desired_order = c('mean.B',
                        'GAM',
                        'DR_mean',
                        'SMexact',
                        'SMcem',
                        'SMunn',
                        'SMrnn',
                        'MMIexact',
                        'MMIcem',
                        'MMIunn',
                        'MMIrnn'
  )
  # 
  total_var =
    f1_results %>% bind_rows(.id = 'iter') %>%
    rowwise() %>%
    dplyr::mutate(LL = mean - qnorm(1-.10/2)*sqrt(boot_var),
                  UL = mean + qnorm(1-.10/2)*sqrt(boot_var),
                  IsIn = ifelse(mu >= LL & mu <= UL, 1, 0)) %>%
    ungroup() %>%
    group_by(mod, r, name) %>%
    dplyr::summarize(boot_var = mean(boot_var),
                     mean = mean(mean),
                     mu = mean(mu),
                     LL = mean(LL),
                     UL = mean(UL),
                     CL = mean(IsIn)) %>%
    left_join(MC_var, by = c('mod', 'r', 'name')) %>%
    filter(name != 'prop_mean') %>% # we aren't doing propensity estimation; just DR
    mutate(name = factor(name, levels = est_desired_order, labels = est_desired_order)) %>%
    arrange(-r, name) %>%
    mutate(d = UL-LL,
           RB = round(100*(boot_var - MC_var)/(MC_var), digits = 1),
           CL = CL * 100) %>%
    dplyr::select(mod, r, name, CL, LL, mean, UL, d, boot_var, RB)

  openxlsx::write.xlsx(total_var, 'total_var.xlsx')
  